with Flts, Globals, Reps, Reps.Balls, Params, Params.Names;
use Flts, Globals, Reps.Balls, Params;
with Matrices, Vectors, ScalVectors, CosSins1, CosSins1.Chain, CosSins1.Chain.Fix;

pragma Elaborate_All (Flts,Globals,Reps.Balls,Params.Names);
pragma Elaborate_All (Matrices,Vectors,ScalVectors,CosSins1.Chain.Fix);

procedure Check_Fixpt(Sol: in Positive) is

  package PN is new Params.Names(Sol => Sol, Trunc => Scalar_IsNumeric);
  use PN;

  subtype Scalar is Ball;

  NumDigits: constant Positive := Reps.Set_Precision(1024);

  package SM is new Matrices (Scalar => Scalar);
  package SV is new Vectors (Component => Scalar);
  package SSV is new ScalVectors (Scalar => Scalar, SM => SM, SV => SV);
  package SCS is new CosSins1 (FDeg => SizeCosSin, Scalar => Scalar, SV => SV);
  package SCSC is new SCS.Chain(JMax => SizeChain, Rho => RhoCh, Rad => RadCS, Phi1 => Phi1, Psi1 => Psi1, SM => SM);
  package Fix is new SCSC.Fix(Par => Par, Mat_PackSize => Mat_PackSize, Sigma => Sigma, TZ => TZ, TPi => TPi, Omega => Omega, SSV => SSV);

  use SM,SCSC,Fix;

  F0,F: FChain;
  M: QC_Matrix;

begin

  Show("",P);
  Read(Input_Dir & Mat_Name,M);
  Read(Input_Dir & Fix_Name & ".approx",F0);
  NumTrunc(SizeCosSin,F0,F);
  ContrFix(M,Contr_PackSize,F,Prefix/="EVEN" and Prefix/="ARPU");
  Write(Output_Dir & Fix_Name,F);

end Check_Fixpt;
