with Flok_Intervals;
use Flok_Intervals;

pragma Elaborate_All (Flok_Intervals);

generic

  Par: in Parity;      --- 0: even in time   1: odd in time
  Sigma: in Parity;    --- 0: site-centered  1: bond-centered
  JAst: in Positive;   --- has to be less than JMax

  with function Pi return Scalar is <>;

package CosSins1.Chain.FlokD is

  Dummy: constant Boolean  := Set_CosSins1_Default(Rad,Par);
  DimX:  constant Positive := 2*JAst+1-Sigma;                   --- KAst, size of the truncated chain

  subtype CSMat is SMatrix(FFreq,1 .. DimX);
  subtype DVec is FltVec(1..DimX);

  procedure MakeAB(Omega: in Rational; Q: in FChain; Alpha,Beta: in out FChain);
  procedure CS2Mat(Alpha,Beta: in FChain; M1,M2: in out CSMat; Dm,Dp: out DVec);
  procedure High_D(Alpha,Beta: in FChain; DMin,DMax: out Flt);
  function High_Eta(BarBeta: Scalar; DMin,DMax: Flt) return F_Intervals;
  function MaxNormPhiDiff(Alpha,Beta: FChain; Dm,Dp: DVec; DMin,DMax: Flt) return Radius;

private

  function MaxNormHminusId(Alpha,Beta: FChain; Pow2: Positive := 12) return Radius;

end CosSins1.Chain.FlokD;
