
generic

  Sigma: in Parity;          --- 0: site-centered  1: bond-centered
  JAst: in Positive;         --- has to be less than JMax

package CosSins1.Chain.Pairs is

  JUst: constant Integer := Sigma-JAst;
  subtype CSVec1 is CSVector(JUst .. JAst);
  type CSVec2 is array (Parity) of CSVec1;

  procedure SetZero(V: in out CSVec2);
  procedure Norm(V: in CSVec2; N: in out Scalar);
  function Norm(V: CSVec2) return Scalar;
  function MaxNorm(V: CSVec2) return Radius;
  procedure Show1(N: in String; V: in CSVec2; Hide0: in Boolean := True);

  procedure Assign(M: in CMode; V: in out CSVec2);
  procedure AddProd(M: in CMode; S: in Scalar; V: in out CSVec2; Check: in Boolean);
  procedure Extract(M: in CMode; V: in out CSVec2; S: in out Scalar; Check: in Boolean);
  function Make(Size: FFreq; Simple,Trunc: Boolean) return CModes;

  DimX:  constant Positive := JAst-Just+1;
  NumErrModes: constant Natural;

private

  NumErrModes: constant Natural := Choose(STrunc,0,2*DimX);

  procedure ParZero(Par: in Parity; V: in out CSVec2);
  procedure ErrsLast(M: in out CModes);

end CosSins1.Chain.Pairs;
