with Flts, Reps, Vectors, Matrices, PolyRoots;
use Flts, Reps;

pragma Elaborate_All (Flts,Reps,Vectors,Matrices,PolyRoots);

package Num_PolyRoots is

  procedure NumRealRoot(Deg: in Positive; WMin,WMax: in Flt; Eps: in Radius);
  procedure NumRealRoots(Deg: in Positive; WMin,WMax: in Flt; Eps: in Radius);
  procedure NumSymQFactor(Deg: in Positive; UMin,UMax: in Flt; Eps: in Radius);
  procedure NumRoots(D: in out Natural);

private

  subtype Numeric is Rep;
  package NV is new Vectors (Component => Numeric);
  subtype NVector is NV.Vector;
  package NM is new Matrices (Scalar => Numeric);
  subtype NMatrix is NM.Matrix;
  package PR is new PolyRoots (Scalar => Numeric, Vector => NVector, Matrix => NMatrix);
  use NV,NM,PR;

  procedure NumRoots(P: in Poly; Wr,Wi: in out Vector; D: out Natural); -- Jenkins & Traub, then Newton

end Num_PolyRoots;
