with Strings;
use Strings;

pragma Elaborate_All (Strings);

generic

  Sol: in Positive;
  Trunc: in Boolean;

package Params.Names is

  P: Param renames PList(Sol);
  Par: Parity renames P.Par;
  SizeChain: Positive renames P.SizeChain;
  SizeCosSin: Positive renames P.SizeCosSin;
  TDeg: Positive renames P.TDeg;
  ExDT: Natural renames P.ExDT;
  JAst: Positive renames P.JAst;
  Sigma: Parity renames P.Sigma;
  TZ: Symmetry renames P.TZ;
  TPi: Symmetry renames P.TPi;
  RadCS: Radius renames P.Rad;
  RhoCh: Radius renames P.Rho;
  Omega: Rational renames P.Om;
  Psi1: Potential renames P.Psi1;
  Phi1: Potential renames P.Phi1;
  RealEV: Natural renames P.RealEV;
  Prefix: String renames P.Prefix;
  HatMaxSize: Positive renames P.HatMaxSize;
  Mat_PackSize: Positive renames P.Mat_PackSize;
  Contr_PackSize: Positive renames P.Contr_PackSize;

  Post: constant String := Choose(Trunc,".approx","");
  M1_Name: constant String := Prefix & "-m1";
  M2_Name: constant String := Prefix & "-m2";
  Dm_Name: constant String := Prefix & "-dm";
  Dp_Name: constant String := Prefix & "-dp";
  Hi_Eta_Name: constant String := Prefix & "-hi-eta";
  Lo_Eta_Name: constant String := Prefix & "-lo-eta";
  Sep_Eta_Name: constant String := Prefix & "-sep-eta";
  Mat_Name: constant String := Prefix & "-mat." & Strng0(Mat_PackSize,2);
  Plot_Name: constant String := Prefix & "-fix.plot";
  NPD_Name: constant String := Prefix & "-npd" & Post;
  Fix_Name: constant String := Prefix & "-fix" & Post;
  Fix_Name_Long: constant String :=  Fix_Name & "." & Strng0(SizeChain,3) & "-" & Strng0(SizeCosSin,3);
  Phi_DPlus_Name: constant String := Prefix & "-phi.D+";
  Phi_DMinus_Name: constant String := Prefix & "-phi.D-";
  Phi_Zero_Name: constant String := Prefix & "-phi0";

  function Phi_Name(Sign: in Integer) return String;

end Params.Names;
