with Strings, Globals;
use Strings, Globals;

package body Params is

  procedure Show(N: in String; P: in Param) is
  begin
    Show0(N & "        Prefix: " & P.Prefix);
    Show1(N & "         Sigma:",P.Sigma);
    Show1(N & "           Par:",P.Par);
    Show1(N & "            TZ: ",P.TZ);
    Show1(N & "           Par:",P.Par);
    Show1(N & "           Rad:",P.Rad);
    Show1(N & "           Rho:",P.Rho);
    Show1(N & "     SizeChain:",P.SizeChain);
    Show1(N & "    SizeCosSin:",P.SizeCosSin);
    Show1(N & "          TDeg:",P.TDeg);
    Show1(N & "          ExDT:",P.ExDT);
    Show1(N & "          JAst:",P.JAst);
    Show1(N & "        RealEV:",P.RealEV);
    Show1(N & "    HatMaxSize:",P.HatMaxSize);
    Show1(N & "  Mat_PackSize:",P.Mat_PackSize);
    Show1(N & "Contr_PackSize:",P.Contr_PackSize);
  end Show;

  procedure Show1(N: in String; T: in Symmetry) is
  begin
    case T is
      when Symm   => Show0(N & "Symmetric");
      when ASymm  => Show0(N & "Antisymmetric");
      when others => Show0(N & "None");
    end case;
  end Show1;

  procedure Put(F: in File_Type; T: in Symmetry) is
    package Txt_IO renames Ada.Text_IO;
  begin
    case T is
      when Symm   => Txt_IO.Put(F,"symm");
      when ASymm  => Txt_IO.Put(F,"asymm");
      when others => Txt_IO.Put(F,"none");
    end case;
    New_Line(F);
  end Put;

  procedure Get(F: in File_Type; T: out Symmetry) is
    S: constant String := Get_Next_Line(F);
  begin
    if    S="symm"  then T := Symm;
    elsif S="asymm" then T := ASymm;
    elsif S="none"  then T := None;
    else  raise Undefined; end if;
  end Get;

  function Max_Size_CosSin(P: Param_List) return Positive is
    Size: Positive := 1;
  begin
    for I in P'Range loop
      Size := IMax(Size,P(I).SizeCosSin);
    end loop;
    return Size;
  end Max_Size_CosSin;

  function Max_Size_Chain(P: Param_List) return Positive is
    Size: Positive := 1;
  begin
    for I in P'Range loop
      Size := IMax(Size,P(I).SizeChain);
    end loop;
    return Size;
  end Max_Size_Chain;

end Params;
