with Flts, Globals, Reps, Params, Params.Names;
use Flts, Globals, Params;
with Flt_Vectors, Matrices, Vectors, ScalVectors;
with Taylors1,MultiTaylors1, MultiTaylors1.Phi;
with Reps.Balls;
use Reps.Balls;

pragma Elaborate_All (Flts,Globals,Reps,Params);
pragma Elaborate_All (Matrices,Vectors,ScalVectors,Taylors1,MultiTaylors1.Phi);

procedure Phi2Pi(Sol: in Positive) is

  package PN is new Params.Names(Sol => Sol, Trunc => Scalar_IsNumeric);
  use PN;

  subtype Scalar is Ball;

  NumDigits: constant Positive := Reps.Set_Precision(1024);
  DimX: constant Positive := 2*JAst+1-Sigma;   ------- size of the truncated chain

  package SM is new Matrices (Scalar => Scalar);
  package SV is new Vectors (Component => Scalar);
  package SSV is new ScalVectors (Scalar => Scalar, SM => SM, SV => SV);
  package Tay is new Taylors1(PDeg => TDeg, Scalar => Scalar, SM => SM, SV => SV);
  package MTay is new Multitaylors1(PDeg => TDeg, Scalar => Scalar, SM => SM, SV => SV, SSV => SSV, ST1 => Tay);
  package MTayPhi is new MTay.Phi(Dim => DimX);

  use MTay,MTayPhi;

  DT: constant Radius := Half**ExDT;

  Dm,Dp: Flt_Vectors.Vector(1..DimX);
  M1: Scalar_Matrix(0..SizeCosSin,1..DimX);
  M2: Scalar_Matrix(0..SizeCosSin,1..DimX);
  Phi00: SMatrix;
  C: YType;

  use SM,SV,Flt_Vectors;

begin

  if TPi/=None then raise Not_Implemented; end if;
  Show_Param;
  Show("",P);
  Verbosity := 2;
  Read(Input_Dir & M1_Name,M1);
  Read(Input_Dir & M2_Name,M2);
  Read(Input_Dir & Dm_Name,Dm);
  Read(Input_Dir & Dp_Name,Dp);

  if RealEV=0 then
    for J in C'Range loop Assign(-Dm(J),C(J)); end loop;
    Run(DT,M1,M2,C,Phi00);
    Write(Output_Dir & Phi_Name(-1),Phi00);
    for J in C'Range loop Assign(Dp(J),C(J)); end loop;
    Run(DT,M1,M2,C,Phi00);
    Write(Output_Dir & Phi_Name(1),Phi00);
  else
    for J in C'Range loop Assign(Zero,C(J)); end loop;
    Run(DT,M1,M2,C,Phi00);
    Write(Output_Dir & Phi_Name(0),Phi00);
  end if;

end Phi2Pi;
