with Globals, Ints, Strings, Params;
use Globals, Ints, Strings, Params;
with Approx_Fixpt,Check_Fixpt,Save_Data, Phi2Pi, Eigen, Separation;

pragma Elaborate_All (Globals,Ints,Approx_Fixpt,Check_Fixpt,Save_Data,Phi2Pi,Eigen,Separation);

procedure Run_All is

  NT: constant Positive := GetArg;      --- number of concurrent tasks

  procedure Run(I: Positive) is
    P: Param renames PList(I);
  begin
    Show1("solution:",I);
    Approx_Fixpt(I);
    Show0("Find_FixptFix done");
    Check_Fixpt(I);
    Show0("Check_Fixpt done");
    if P.ExDT>0 then
      Save_Data(I);
      Show0("Data saved");
      Phi2pi(I);
      Show0("matrizant computed");
      Eigen(I);
      Show0("eigenthings computed");
      if P.RealEV=0 then Separation(I); end if;
    end if;
  end Run;

begin

  Verbosity := 1;
  NTasks := NT;
  for I in PList'Range loop Run(I); end loop;

end Run_All;
