with Flts, Globals, Reps, Params, Params.Names, Flok_Intervals;
use Flts, Globals, Params, Flok_Intervals;
with Flt_Vectors, Matrices, Vectors, CosSins1, CosSins1.Chain, CosSins1.Chain.FlokD;

with Reps.Balls;
use Reps.Balls;

pragma Elaborate_All (Flts,Globals,Reps,Params.Names,Flok_Intervals);
pragma Elaborate_All (Flt_Vectors,Matrices,Vectors,CosSins1.Chain.FlokD);

procedure Save_Data(Sol: in Positive) is

  package PN is new Params.Names(Sol => Sol, Trunc => Scalar_IsNumeric);
  use PN;

  subtype Scalar is Ball;

  NumDigits: constant Positive := Reps.Set_Precision(1024);

  package SM is new Matrices (Scalar => Scalar);
  package SV is new Vectors (Component => Scalar);
  package SCS is new CosSins1 (FDeg => SizeCosSin, Scalar => Scalar, SV => SV);
  package SCSC is new SCS.Chain(JMax => SizeChain, Rho => RhoCh, Rad => RadCS, Phi1 => Phi1, Psi1 => Psi1, SM => SM);
  package SCSCF is new SCSC.FlokD(Par => Par, Sigma => Sigma, JAst => JAst);

  use Flt_Vectors,SCSC,SM,SV,SCSCF;

  DMin,DMax,NPD: Flt;
  Dm,Dp: DVec;
  F,Alpha,Beta: FChain;
  M1,M2: CSMat;

begin

  Show("",P);
  Read(Input_Dir & Fix_Name,F);
  MakeAB(Omega,F,Alpha,Beta);
  CS2Mat(Alpha,Beta,M1,M2,Dm,Dp);
  Write(Output_Dir & M1_Name,M1);
  Write(Output_Dir & M2_Name,M2);
  Write(Output_Dir & Dm_Name,Dm);
  Write(Output_Dir & Dp_Name,Dp);

  High_D(Alpha,Beta,DMin,DMax);
  declare
    Hi: constant F_Intervals := High_Eta(Beta.A,DMin,DMax);
  begin
    Write(Output_Dir & Hi_Eta_Name,Hi,False);
    Write(Output_Dir & Hi_Eta_Name & ".dec",Hi,True);
  end;

  if RealEV>0 then
    NPD := MaxNormPhiDiff(Alpha,Beta,Dm,Dp,DMin,DMax); --- useful only if RealEV>0
    if Verbosity>0 then Show1("NPD:",NPD); end if;
    Flt_FS.Write(Output_Dir & NPD_Name,NPD);
  end if;

end Save_Data;
