with Flok_Intervals;
use Flok_Intervals;

pragma Elaborate_All (Flok_Intervals);

generic

  with procedure ArcCos(S1: in Scalar; S2: in out Scalar) is <>;

package ScalVectors.Phi is

  function FindMu(Wr: Vector) return Radius;
  function Check_Unstable(Phi: Matrix; Mu,NPD: Radius) return Boolean;

  procedure IndexG(Vr,Vi: in Vector; S: in out Scalar);
  procedure IndexG(J: in Positive; Vr,Vi: in Matrix; S: in out Scalar);
  procedure PosIndexG(Wr: in Vector; Wi: in out Vector; Vr: in Matrix; Vi: in out Matrix);

  function Low_Eta(Wr,Wi: Vector; Vr,Vi: Matrix) return F_Intervals;
  function Separating_Eta(Low,High: F_Intervals) return FltVec;

  --- plotting
  procedure Plot_Circle(Name: in String; Steps: in Positive := 256);
  procedure Plot_Eigen_Circle(Stem: in String; Wr: in Vector);
  procedure Plot_Eigen_Pos(Stem: in String; Wr,Wi: in Vector);
  procedure Plot_Eigen_Neg(Stem: in String; Wr,Wi: in Vector);
  function Count_Eigen_Zero(Wr: Vector) return Natural;
  procedure Plot_Eigen_Zero(Stem: in String; Wr: in Vector);

end ScalVectors.Phi;
