with Flts, Globals, Ints, Params, Params.Names, Flt_Vectors, ScalVectors;
use Flts, Globals, Ints, Params;
with Matrices, Vectors, CosSins1, CosSins1.Chain, CosSins1.Chain.Pairs, CosSins1.Chain.Pairs.FlokM;

with Reps, Reps.Balls;
use Reps.Balls;

pragma Elaborate_All (Flts,Globals,Params.Names,Flt_Vectors,ScalVectors);
pragma Elaborate_All (Matrices,Vectors,CosSins1.Chain.Pairs.FlokM);


procedure Separation(Sol: in Positive) is

  package PN is new Params.Names(Sol => Sol, Trunc => Scalar_IsNumeric);
  use PN;

  subtype Scalar is Ball;

  NumDigits: constant Positive := Reps.Set_Precision(1024);
  FDeg: constant Positive := IMax(HatMaxSize,SizeCosSin);

  package SM is new Matrices (Scalar => Scalar);
  package SV is new Vectors (Component => Scalar);
  package SSV is new ScalVectors (Scalar => Scalar, SM => SM, SV => SV);
  package SCS is new CosSins1 (FDeg => FDeg, Scalar => Scalar, SV => SV);
  package SCSC is new SCS.Chain(JMax => SizeChain, Rho => One, Rad => One, Phi1 => Phi1, Psi1 => Psi1, SM => SM);
  package SCSCP is new SCSC.Pairs(Sigma => Sigma, JAst => JAst);
  package SCSCPF is new SCSCP.FlokM (MaxSize => HatMaxSize, SSV => SSV);

  use SCSC,SCSCP,SCSCPF,SM,SV,SSV,Flt_Vectors;

  Sep_Eta: constant FltVec := Read(Input_Dir & Sep_Eta_Name,1);
  Dm,Dp: DVec;
  M1,M2: CSMat;
  D: SVec;
  AB: CSVec2;

begin

  Show("",P);

  Read(Input_Dir & Dm_Name,Dm);
  Read(Input_Dir & Dp_Name,Dp);
  Read(Input_Dir & M1_Name,M1);
  Read(Input_Dir & M2_Name,M2);

  MatProd_Parallel := True;
  MakeD(Dm,Dp,D);
  Mat2CS(M1,M2,Dm,Dp,AB);
  CheckEta(Sep_Eta,D,AB);

end Separation;
